//#line 2 "/home/eaibot/2022_jsjds/ros_ws/install/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"
// *********************************************************
//
// File autogenerated for the theora_image_transport package
// by the dynamic_reconfigure package.
// Please do not edit.
//
// ********************************************************/

#ifndef __theora_image_transport__THEORAPUBLISHERCONFIG_H__
#define __theora_image_transport__THEORAPUBLISHERCONFIG_H__

#if __cplusplus >= 201103L
#define DYNAMIC_RECONFIGURE_FINAL final
#else
#define DYNAMIC_RECONFIGURE_FINAL
#endif

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/Group.h>
#include <dynamic_reconfigure/config_init_mutex.h>
#include <boost/any.hpp>

namespace theora_image_transport
{
  class TheoraPublisherConfigStatics;

  class TheoraPublisherConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l,
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }

      virtual void clamp(TheoraPublisherConfig &config, const TheoraPublisherConfig &max, const TheoraPublisherConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const TheoraPublisherConfig &config1, const TheoraPublisherConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, TheoraPublisherConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const TheoraPublisherConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, TheoraPublisherConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const TheoraPublisherConfig &config) const = 0;
      virtual void getValue(const TheoraPublisherConfig &config, boost::any &val) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;

    // Final keyword added to class because it has virtual methods and inherits
    // from a class with a non-virtual destructor.
    template <class T>
    class ParamDescription DYNAMIC_RECONFIGURE_FINAL : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string a_name, std::string a_type, uint32_t a_level,
          std::string a_description, std::string a_edit_method, T TheoraPublisherConfig::* a_f) :
        AbstractParamDescription(a_name, a_type, a_level, a_description, a_edit_method),
        field(a_f)
      {}

      T (TheoraPublisherConfig::* field);

      virtual void clamp(TheoraPublisherConfig &config, const TheoraPublisherConfig &max, const TheoraPublisherConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;

        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const TheoraPublisherConfig &config1, const TheoraPublisherConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, TheoraPublisherConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const TheoraPublisherConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, TheoraPublisherConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const TheoraPublisherConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }

      virtual void getValue(const TheoraPublisherConfig &config, boost::any &val) const
      {
        val = config.*field;
      }
    };

    class AbstractGroupDescription : public dynamic_reconfigure::Group
    {
      public:
      AbstractGroupDescription(std::string n, std::string t, int p, int i, bool s)
      {
        name = n;
        type = t;
        parent = p;
        state = s;
        id = i;
      }

      std::vector<AbstractParamDescriptionConstPtr> abstract_parameters;
      bool state;

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &config) const =0;
      virtual void updateParams(boost::any &cfg, TheoraPublisherConfig &top) const= 0;
      virtual void setInitialState(boost::any &cfg) const = 0;


      void convertParams()
      {
        for(std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = abstract_parameters.begin(); i != abstract_parameters.end(); ++i)
        {
          parameters.push_back(dynamic_reconfigure::ParamDescription(**i));
        }
      }
    };

    typedef boost::shared_ptr<AbstractGroupDescription> AbstractGroupDescriptionPtr;
    typedef boost::shared_ptr<const AbstractGroupDescription> AbstractGroupDescriptionConstPtr;

    // Final keyword added to class because it has virtual methods and inherits
    // from a class with a non-virtual destructor.
    template<class T, class PT>
    class GroupDescription DYNAMIC_RECONFIGURE_FINAL : public AbstractGroupDescription
    {
    public:
      GroupDescription(std::string a_name, std::string a_type, int a_parent, int a_id, bool a_s, T PT::* a_f) : AbstractGroupDescription(a_name, a_type, a_parent, a_id, a_s), field(a_f)
      {
      }

      GroupDescription(const GroupDescription<T, PT>& g): AbstractGroupDescription(g.name, g.type, g.parent, g.id, g.state), field(g.field), groups(g.groups)
      {
        parameters = g.parameters;
        abstract_parameters = g.abstract_parameters;
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        if(!dynamic_reconfigure::ConfigTools::getGroupState(msg, name, (*config).*field))
          return false;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          if(!(*i)->fromMessage(msg, n))
            return false;
        }

        return true;
      }

      virtual void setInitialState(boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        T* group = &((*config).*field);
        group->state = state;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = boost::any(&((*config).*field));
          (*i)->setInitialState(n);
        }

      }

      virtual void updateParams(boost::any &cfg, TheoraPublisherConfig &top) const
      {
        PT* config = boost::any_cast<PT*>(cfg);

        T* f = &((*config).*field);
        f->setParams(top, abstract_parameters);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          (*i)->updateParams(n, top);
        }
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &cfg) const
      {
        const PT config = boost::any_cast<PT>(cfg);
        dynamic_reconfigure::ConfigTools::appendGroup<T>(msg, name, id, parent, config.*field);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          (*i)->toMessage(msg, config.*field);
        }
      }

      T (PT::* field);
      std::vector<TheoraPublisherConfig::AbstractGroupDescriptionConstPtr> groups;
    };

class DEFAULT
{
  public:
    DEFAULT()
    {
      state = true;
      name = "Default";
    }

    void setParams(TheoraPublisherConfig &config, const std::vector<AbstractParamDescriptionConstPtr> params)
    {
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator _i = params.begin(); _i != params.end(); ++_i)
      {
        boost::any val;
        (*_i)->getValue(config, val);

        if("optimize_for"==(*_i)->name){optimize_for = boost::any_cast<int>(val);}
        if("target_bitrate"==(*_i)->name){target_bitrate = boost::any_cast<int>(val);}
        if("quality"==(*_i)->name){quality = boost::any_cast<int>(val);}
        if("keyframe_frequency"==(*_i)->name){keyframe_frequency = boost::any_cast<int>(val);}
      }
    }

    int optimize_for;
int target_bitrate;
int quality;
int keyframe_frequency;

    bool state;
    std::string name;

    
}groups;



//#line 290 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int optimize_for;
//#line 290 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int target_bitrate;
//#line 290 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int quality;
//#line 290 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int keyframe_frequency;
//#line 228 "/home/eaibot/2022_jsjds/ros_ws/install/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();

      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        if ((*i)->fromMessage(msg, *this))
          count++;

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i ++)
      {
        if ((*i)->id == 0)
        {
          boost::any n = boost::any(this);
          (*i)->updateParams(n, *this);
          (*i)->fromMessage(msg, n);
        }
      }

      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("TheoraPublisherConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__, const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toMessage(msg, *this);

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        if((*i)->id == 0)
        {
          (*i)->toMessage(msg, *this);
        }
      }
    }

    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      __toMessage__(msg, __param_descriptions__, __group_descriptions__);
    }

    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      static bool setup=false;

      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->fromServer(nh, *this);

      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i++){
        if (!setup && (*i)->id == 0) {
          setup = true;
          boost::any n = boost::any(this);
          (*i)->setInitialState(n);
        }
      }
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const TheoraPublisherConfig &__max__ = __getMax__();
      const TheoraPublisherConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const TheoraPublisherConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->calcLevel(level, config, *this);
      return level;
    }

    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const TheoraPublisherConfig &__getDefault__();
    static const TheoraPublisherConfig &__getMax__();
    static const TheoraPublisherConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    static const std::vector<AbstractGroupDescriptionConstPtr> &__getGroupDescriptions__();

  private:
    static const TheoraPublisherConfigStatics *__get_statics__();
  };

  template <> // Max and min are ignored for strings.
  inline void TheoraPublisherConfig::ParamDescription<std::string>::clamp(TheoraPublisherConfig &config, const TheoraPublisherConfig &max, const TheoraPublisherConfig &min) const
  {
    (void) config;
    (void) min;
    (void) max;
    return;
  }

  class TheoraPublisherConfigStatics
  {
    friend class TheoraPublisherConfig;

    TheoraPublisherConfigStatics()
    {
TheoraPublisherConfig::GroupDescription<TheoraPublisherConfig::DEFAULT, TheoraPublisherConfig> Default("Default", "", 0, 0, true, &TheoraPublisherConfig::groups);
//#line 290 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.optimize_for = 0;
//#line 290 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.optimize_for = 1;
//#line 290 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.optimize_for = 1;
//#line 290 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(TheoraPublisherConfig::AbstractParamDescriptionConstPtr(new TheoraPublisherConfig::ParamDescription<int>("optimize_for", "int", 0, "Try to achieve either 'target_bitrate' or 'quality'", "{'enum': [{'name': 'Bitrate', 'type': 'int', 'value': 0, 'srcline': 9, 'srcfile': '/home/eaibot/2022_jsjds/ros_ws/src/image_transport_plugins/theora_image_transport/cfg/TheoraPublisher.cfg', 'description': 'Aim for requested bitrate', 'ctype': 'int', 'cconsttype': 'const int'}, {'name': 'Quality', 'type': 'int', 'value': 1, 'srcline': 10, 'srcfile': '/home/eaibot/2022_jsjds/ros_ws/src/image_transport_plugins/theora_image_transport/cfg/TheoraPublisher.cfg', 'description': 'Aim for requested quality', 'ctype': 'int', 'cconsttype': 'const int'}], 'enum_description': 'Enum to control whether optimizing for bitrate or quality'}", &TheoraPublisherConfig::optimize_for)));
//#line 290 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(TheoraPublisherConfig::AbstractParamDescriptionConstPtr(new TheoraPublisherConfig::ParamDescription<int>("optimize_for", "int", 0, "Try to achieve either 'target_bitrate' or 'quality'", "{'enum': [{'name': 'Bitrate', 'type': 'int', 'value': 0, 'srcline': 9, 'srcfile': '/home/eaibot/2022_jsjds/ros_ws/src/image_transport_plugins/theora_image_transport/cfg/TheoraPublisher.cfg', 'description': 'Aim for requested bitrate', 'ctype': 'int', 'cconsttype': 'const int'}, {'name': 'Quality', 'type': 'int', 'value': 1, 'srcline': 10, 'srcfile': '/home/eaibot/2022_jsjds/ros_ws/src/image_transport_plugins/theora_image_transport/cfg/TheoraPublisher.cfg', 'description': 'Aim for requested quality', 'ctype': 'int', 'cconsttype': 'const int'}], 'enum_description': 'Enum to control whether optimizing for bitrate or quality'}", &TheoraPublisherConfig::optimize_for)));
//#line 290 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.target_bitrate = 0;
//#line 290 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.target_bitrate = 99200000;
//#line 290 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.target_bitrate = 800000;
//#line 290 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(TheoraPublisherConfig::AbstractParamDescriptionConstPtr(new TheoraPublisherConfig::ParamDescription<int>("target_bitrate", "int", 0, "Target encoding bitrate, bits per second", "", &TheoraPublisherConfig::target_bitrate)));
//#line 290 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(TheoraPublisherConfig::AbstractParamDescriptionConstPtr(new TheoraPublisherConfig::ParamDescription<int>("target_bitrate", "int", 0, "Target encoding bitrate, bits per second", "", &TheoraPublisherConfig::target_bitrate)));
//#line 290 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.quality = 0;
//#line 290 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.quality = 63;
//#line 290 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.quality = 31;
//#line 290 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(TheoraPublisherConfig::AbstractParamDescriptionConstPtr(new TheoraPublisherConfig::ParamDescription<int>("quality", "int", 0, "Encoding quality", "", &TheoraPublisherConfig::quality)));
//#line 290 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(TheoraPublisherConfig::AbstractParamDescriptionConstPtr(new TheoraPublisherConfig::ParamDescription<int>("quality", "int", 0, "Encoding quality", "", &TheoraPublisherConfig::quality)));
//#line 290 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.keyframe_frequency = 1;
//#line 290 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.keyframe_frequency = 64;
//#line 290 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.keyframe_frequency = 64;
//#line 290 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(TheoraPublisherConfig::AbstractParamDescriptionConstPtr(new TheoraPublisherConfig::ParamDescription<int>("keyframe_frequency", "int", 0, "Maximum distance between key frames", "", &TheoraPublisherConfig::keyframe_frequency)));
//#line 290 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(TheoraPublisherConfig::AbstractParamDescriptionConstPtr(new TheoraPublisherConfig::ParamDescription<int>("keyframe_frequency", "int", 0, "Maximum distance between key frames", "", &TheoraPublisherConfig::keyframe_frequency)));
//#line 245 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.convertParams();
//#line 245 "/home/eaibot/2022_jsjds/ros_ws/install/lib/python3.6/site-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __group_descriptions__.push_back(TheoraPublisherConfig::AbstractGroupDescriptionConstPtr(new TheoraPublisherConfig::GroupDescription<TheoraPublisherConfig::DEFAULT, TheoraPublisherConfig>(Default)));
//#line 366 "/home/eaibot/2022_jsjds/ros_ws/install/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

      for (std::vector<TheoraPublisherConfig::AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        __description_message__.groups.push_back(**i);
      }
      __max__.__toMessage__(__description_message__.max, __param_descriptions__, __group_descriptions__);
      __min__.__toMessage__(__description_message__.min, __param_descriptions__, __group_descriptions__);
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__, __group_descriptions__);
    }
    std::vector<TheoraPublisherConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    std::vector<TheoraPublisherConfig::AbstractGroupDescriptionConstPtr> __group_descriptions__;
    TheoraPublisherConfig __max__;
    TheoraPublisherConfig __min__;
    TheoraPublisherConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;

    static const TheoraPublisherConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static TheoraPublisherConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &TheoraPublisherConfig::__getDescriptionMessage__()
  {
    return __get_statics__()->__description_message__;
  }

  inline const TheoraPublisherConfig &TheoraPublisherConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }

  inline const TheoraPublisherConfig &TheoraPublisherConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }

  inline const TheoraPublisherConfig &TheoraPublisherConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }

  inline const std::vector<TheoraPublisherConfig::AbstractParamDescriptionConstPtr> &TheoraPublisherConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const std::vector<TheoraPublisherConfig::AbstractGroupDescriptionConstPtr> &TheoraPublisherConfig::__getGroupDescriptions__()
  {
    return __get_statics__()->__group_descriptions__;
  }

  inline const TheoraPublisherConfigStatics *TheoraPublisherConfig::__get_statics__()
  {
    const static TheoraPublisherConfigStatics *statics;

    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = TheoraPublisherConfigStatics::get_instance();

    return statics;
  }

//#line 9 "/home/eaibot/2022_jsjds/ros_ws/src/image_transport_plugins/theora_image_transport/cfg/TheoraPublisher.cfg"
      const int TheoraPublisher_Bitrate = 0;
//#line 10 "/home/eaibot/2022_jsjds/ros_ws/src/image_transport_plugins/theora_image_transport/cfg/TheoraPublisher.cfg"
      const int TheoraPublisher_Quality = 1;
}

#undef DYNAMIC_RECONFIGURE_FINAL

#endif // __THEORAPUBLISHERRECONFIGURATOR_H__
